module lect_clim_act_greeneem_mar
! c'est pour une version annuelle utilisant les donnees mar.

  use module3D_phy
  use ablation_ann          ! le module pdd base sur Tann et Tjuly

  real,dimension(nx,ny) :: S0CLIM             ! topo de reference du GCM

contains
 
subroutine input_climat_ref()



! pour les precip et la temp on prend les valeurs mensuelles et on en deduit des Tann/tjuly
real,dimension(nx,ny,12) :: Tm      ! temperature mensuelle sur la calotte de ref
real,dimension(nx,ny,12) :: Pm      ! precipitation mensuelle sur la calotte de ref


character(len=200) :: filin  !nom temporaire
character (len=200) :: filtr_topo, filtr_t, filtr_p

real :: ti, tj                     ! variable provisoire de lecture


namelist/clim_init_ann/filtr_topo,filtr_t,filtr_p 


! formats pour les ecritures dans 42
428 format(A)

rewind(num_param)        ! pour revenir au debut du fichier param_list.dat
read(num_param,clim_init_ann)


write(num_rep_42,428)'!___________________________________________________________' 
write(num_rep_42,428) '&clim_perturb_ann                            ! module climat_perturb_mar_mod'
write(num_rep_42,'(A,A)')   'filtr_topo =', filtr_topo
write(num_rep_42,'(A,A)')   'filtr_t =', filtr_t
write(num_rep_42,'(A,A)')   'filtr_p =', filtr_p
write(num_rep_42,*)'/'                      
write(num_rep_42,428) '! fichiers temperature et precip : 12 mois'
write(num_rep_42,428) '! faire un bloc namelist par snapshot'
write(num_rep_42,*)



write(6,*) 'fichiers snapshots'
 
! lecture de la topo de surface de reference du GCM
filin=trim(dirnameinp)//trim(filtr_topo)
write(6,*) filin
open(20,file=filin)
do j=1,ny 
   do i=1,nx
      read (20,*) S0CLIM(i,j)
      S0CLIM(i,j)=max(S0CLIM(i,j),slv(i,j))   ! pour etre au niveau des mers
   end do
end do
close(20)


! temperature : temperature a l'altitude de la calotte de ref (MAR)
filin=trim(dirnameinp)//trim(filtr_t)
write(6,*) filin
open(20,file=filin)
do j=1,ny
   do i=1,nx
      read(20,*) ti, tj, (Tm(i,j,mo),mo=1,12)
   end do
end do
close(20)
   
! precipitation a l'altitude de la calotte de ref (MAR)
filin=trim(dirnameinp)//trim(filtr_p)
write(6,*) filin
open(20,file=filin)
do j=1,ny
   do i=1,nx
      read(20,*) ti, tj, (Pm(i,j,mo),mo=1,12)
   end do
end do
close(20)

do j=1,ny
   do i=1,nx
      Tann(i,j)=sum(Tm(i,j,:))/12 
      Tjuly(i,j)=Tm(i,j,7)
      !Tjuly(i,j)=(Tm_surf(i,j,6)+Tm_surf(i,j,7)+Tm_surf(i,j,8))/3 ! en fait un Tjja
      precip(i,j)=sum(Pm(i,j,:))/12 !attention a l'unite des precipes mensuelles (mm/mois ramenee sur l'annee...)
      if(Tann(i,j).lt.(-10)) then
         acc(i,j)=precip(i,j)
      else if(Tann(i,j).lt.(-2)) then
         acc(i,j)=0.9*precip(i,j)
      else if(Tann(i,j).lt.2) then
         acc(i,j)=0.8*precip(i,j)
      else if(Tann(i,j).lt.(5)) then
         acc(i,j)=0.6*precip(i,j)
      else 
         acc(i,j)=0.
      end if
   end do
end do




! temperature a l'altitude du GCM
TA0(:,:)=Tann(:,:)  
TJ0(:,:)=Tjuly(:,:)

call Tsgreen

Tann(:,:)=Tann(:,:)+Tafor
Tjuly(:,:)=Tjuly(:,:)+Tafor

do j=1,ny
   do i=1,nx
      if(retroac.eq.1) then           ! full retroaction acc. 
         acc(i,j)=precip(i,j)*exp(rappact*(tann(i,j)-ta0(i,j)))        
      else if(retroac.eq.0) then
         acc(i,j)=precip(i,j)
      endif
   end do
end do

end subroutine input_climat_ref

!---------------------------------------------------------------------------------------------
! parametrisation de la temperature . Cette routine gere la partie dependance en altitude
! c'est donc le S courant qui compte

subroutine Tsgreen
  
  real alti
  real lapse_ann
  real lapse_july



! valeur de lapse de Fausto et al. 
  lapse_ann = -6.309/1000
  lapse_july = -5.426/1000


  do j=1,ny
     do i=1,nx
        alti=max(slv(i,j),S(I,J))
        Tann(i,j)=TA0(i,j)+lapse_ann*(alti-S0CLIM(i,j))
        Tjuly(i,j)=TJ0(i,j)+lapse_july*(alti-S0CLIM(i,j))
     end do
  end do
  !  la retroac des precipes de fait dans massb
  
end subroutine Tsgreen


end module  lect_clim_act_greeneem_mar
